 /**
 * LBS drawRing 
 * Date: 2015-04-24
 * ==================================
 * opts.parent 插入到哪里 一个JS元素对象
 * opts.width 宽度 = 2* (半径+弧宽)  
 * opts.radius 半径
 * opts.arc 弧宽
 * opts.perent 百分比 
 * opts.color 弧渲染颜色 [底色,进度色]
 * opts.textColor 文字渲染颜色
 * opts.textSize 文字渲染大小
 * opts.animated 是否以动画的方式绘制 默认false
 * opts.after 绘制完成时执行函数
 * ==================================
 **/

function drawRing(opts) {
    var _opts = {
        parent: document.body,
        width: 100,
        radius: 45,
        arc: 5,
        perent: 100,
		total:100,
		score:60,
        color: ['#ccc', '#042b61'],
        textColor: '#000',
        textSize: '14px',
        animated: false,
        after: function() {}
    }, k;
    for (k in opts) _opts[k] = opts[k];
    
    var parent = _opts.parent,
        width = _opts.width,
        radius = _opts.radius,
        arc = _opts.arc,
        perent = parseFloat(_opts.perent),
		total = parseFloat(_opts.total),
		score = parseFloat(_opts.score),
        color = _opts.color,
        textSize = _opts.textSize,
        textColor = _opts.textColor,
        c = document.createElement('canvas'),
        ctx = null,
        x = 0,
        animated = _opts.animated,
        after = _opts.after;

    parent.appendChild(c);
    ctx = c.getContext("2d");
    ctx.canvas.width = width;
    ctx.canvas.height = width;

    function clearFill() {
        ctx.clearRect(0, 0, width, width);
    }

    function fillBG() {
        ctx.beginPath();
        ctx.lineWidth = arc;
        ctx.strokeStyle = color[0];
        ctx.arc(width / 2, width / 2, radius, 0, 2 * Math.PI);
        ctx.stroke();
    }

    function fillArc(perent) {
        ctx.beginPath();
        ctx.lineWidth = arc;
        ctx.strokeStyle = color[1];
        ctx.arc(width / 2, width / 2, radius, -90 * Math.PI / 180, (perent * 3.6 - 90) * Math.PI / 180,true);
        ctx.stroke();
    }

    function fillText(score,total) {
        ctx.font = 'bold '+textSize + ' sans-serif';
        ctx.fillStyle = textColor;
        ctx.textBaseline = "middle";
        ctx.textAlign = 'center';
		ctx.fillText("我的分数",width / 2, width / 2 - 45);
		if(Math.round(score)==score){
			ctx.font = '70px sans-serif';
		}else{
			ctx.font = '60px sans-serif';
		}
		
        ctx.fillText(score, width / 2, width / 2);
		ctx.font = 'bold '+textSize + ' sans-serif';
		ctx.fillText('总分：'+total+'分', width / 2, width / 2+42);
    }

    function fill(score,total,perent) {
        fillBG();
        fillArc(perent);
        fillText(score,total);
    }

    if (!animated) return fill(score,total);

    fill(score,total);
    !function animate() {
		if (++x > score*100/total) return after && after();
        setTimeout(animate, 10);
        clearFill();
        fill(score,total,x);
    }();
}